# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BranchMerge(BaseModel):
    """
    BranchMerge
    """ # noqa: E501
    id: Optional[StrictStr] = None
    branch_id: Optional[StrictStr] = Field(default=None, alias="branchId")
    source_branch: Optional[StrictStr] = Field(default=None, alias="sourceBranch")
    target_branch: Optional[StrictStr] = Field(default=None, alias="targetBranch")
    merge_status: Optional[StrictStr] = Field(default=None, alias="mergeStatus")
    merge_strategy: Optional[StrictStr] = Field(default=None, alias="mergeStrategy")
    conflicts: Optional[List[StrictStr]] = None
    merger_id: Optional[StrictStr] = Field(default=None, alias="mergerId")
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    completed_at: Optional[datetime] = Field(default=None, alias="completedAt")
    __properties: ClassVar[List[str]] = ["id", "branchId", "sourceBranch", "targetBranch", "mergeStatus", "mergeStrategy", "conflicts", "mergerId", "createdAt", "completedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BranchMerge from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BranchMerge from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "branchId": obj.get("branchId"),
            "sourceBranch": obj.get("sourceBranch"),
            "targetBranch": obj.get("targetBranch"),
            "mergeStatus": obj.get("mergeStatus"),
            "mergeStrategy": obj.get("mergeStrategy"),
            "conflicts": obj.get("conflicts"),
            "mergerId": obj.get("mergerId"),
            "createdAt": obj.get("createdAt"),
            "completedAt": obj.get("completedAt")
        })
        return _obj


