# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from playbookmedia_backend_client_sdk.models.compliance_score import ComplianceScore
from playbookmedia_backend_client_sdk.models.compliance_violation import ComplianceViolation
from typing import Optional, Set
from typing_extensions import Self

class GetWorkspaceComplianceReportResponse(BaseModel):
    """
    GetWorkspaceComplianceReportResponse
    """ # noqa: E501
    overall_score: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, alias="overallScore")
    compliance_status: Optional[StrictStr] = Field(default=None, alias="complianceStatus")
    violations: Optional[List[ComplianceViolation]] = None
    category_scores: Optional[List[ComplianceScore]] = Field(default=None, alias="categoryScores")
    report_generated_at: Optional[datetime] = Field(default=None, alias="reportGeneratedAt")
    certification_id: Optional[StrictStr] = Field(default=None, alias="certificationId")
    __properties: ClassVar[List[str]] = ["overallScore", "complianceStatus", "violations", "categoryScores", "reportGeneratedAt", "certificationId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetWorkspaceComplianceReportResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in violations (list)
        _items = []
        if self.violations:
            for _item in self.violations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['violations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in category_scores (list)
        _items = []
        if self.category_scores:
            for _item in self.category_scores:
                if _item:
                    _items.append(_item.to_dict())
            _dict['categoryScores'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetWorkspaceComplianceReportResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "overallScore": obj.get("overallScore"),
            "complianceStatus": obj.get("complianceStatus"),
            "violations": [ComplianceViolation.from_dict(_item) for _item in obj["violations"]] if obj.get("violations") is not None else None,
            "categoryScores": [ComplianceScore.from_dict(_item) for _item in obj["categoryScores"]] if obj.get("categoryScores") is not None else None,
            "reportGeneratedAt": obj.get("reportGeneratedAt"),
            "certificationId": obj.get("certificationId")
        })
        return _obj


