# coding: utf-8

"""
    Lead Scraping Service API

    Vector Lead Scraping Service API - Manages Lead Scraping Jobs

    The version of the OpenAPI document: 1.0
    Contact: yoanyomba@vector.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SignatureWorkflow(BaseModel):
    """
    SignatureWorkflow
    """ # noqa: E501
    id: Optional[StrictStr] = None
    request_id: Optional[StrictStr] = Field(default=None, alias="requestId")
    signing_order: Optional[List[StrictStr]] = Field(default=None, alias="signingOrder")
    current_signer: Optional[StrictStr] = Field(default=None, alias="currentSigner")
    workflow_status: Optional[StrictStr] = Field(default=None, alias="workflowStatus")
    parallel_signing: Optional[StrictBool] = Field(default=None, alias="parallelSigning")
    require_all_signatures: Optional[StrictBool] = Field(default=None, alias="requireAllSignatures")
    deadline: Optional[datetime] = None
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    __properties: ClassVar[List[str]] = ["id", "requestId", "signingOrder", "currentSigner", "workflowStatus", "parallelSigning", "requireAllSignatures", "deadline", "createdAt", "updatedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignatureWorkflow from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignatureWorkflow from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "requestId": obj.get("requestId"),
            "signingOrder": obj.get("signingOrder"),
            "currentSigner": obj.get("currentSigner"),
            "workflowStatus": obj.get("workflowStatus"),
            "parallelSigning": obj.get("parallelSigning"),
            "requireAllSignatures": obj.get("requireAllSignatures"),
            "deadline": obj.get("deadline"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt")
        })
        return _obj


